import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.xml.sax.*;
import java.io.*;
import java.util.*;

public class ffmpegProcessor
{
	boolean ready_to_process = false;

	/* MULTI-THREADING NOT IMPLEMENTED
	 *
	 * boolean multi_thread = false;
	 int thread_count = 3;*/

	long video_rate = 1700;
	boolean overwrite_video_rate = false;

	long audio_rate = 192;
	boolean overwrite_audio_rate = false;

	String library_path = ".\\library\\";
	boolean overwrite_library_path = false;

	String output_format = "avi";
	boolean overwrite_output_format = false;

	String vcodec = "mpeg4";
	boolean overwrite_vcodec = false;

	String acodec = "mp2";
	boolean overwrite_acodec = false;

	String pickup_location = ".";

	boolean create_my_file = true;

	boolean delete_source = false;
	boolean overwrite_delete_source = false;

	String exe_command = "ffmpeg -i @INPUT @QUALITY @SIZE -deinterlace -y -f @OUTPUT_FORMAT @VSYNC -vcodec @VCODEC -b @VIDEO_RATE -g 300 -bf 2 -acodec @ACODEC -ab @AUDIO_RATE @ASYNC @OUTPUT";
	boolean overwrite_exe_command;

	String viewing_size = "";
	String viewing_size_flag = "-s";
	boolean overwrite_viewing_size = false;

	String quality = "";
	boolean overwrite_quality = false;

	String async = "";
	String async_flag = "";
	boolean overwrite_async = false;

	String vsync = "";
	String vsync_flag = "";
	boolean overwrite_vsync = false;

	String starting_program = "ffmpeg_convert.exe";
	//boolean overwrite_starting_program = false;  NOT IN USE

	String pickup_file_ext = ".xml";

	String active_log = ".\\active_log.xml";

	Vector attempted_xml = new Vector();


	public ffmpegProcessor(String props_filename)
	{
		xml_processor props = new xml_processor(props_filename);

		if (props.readableDoc() == true)
			ready_to_process = true;	//yay, let's rock'n'roll
		else
			return;	//don't attempt to go any further

		String tmpstr = "";

		/* MULTI-THREADING NOT IMPLEMENTED
		 * 
		 //Check to see if the user wants to try threading
		 tmpstr = props.getElement("Enabled", "Threads");
		 if (tmpstr.equalsIgnoreCase("True"))
		 {
		 multi_thread = true;
		 tmpstr = props.getElement("Value", "Threads");

		 try
		 {
		 thread_count = Integer.parseInt(tmpstr);
		 }
		 catch (Exception e)
		 {
		 System.out.println("Invalid thread value property: " + e);
		 }
		 }*/

		//Check to see if the video rate is enabled
		tmpstr = props.getElement("Enabled", "Video_Rate");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_video_rate = true;
			tmpstr = props.getElement("Value", "Video_Rate");

			try
			{
				video_rate = Long.parseLong(tmpstr);
			}
			catch (Exception e)
			{
				System.out.println("Invalid video rate value property: " + e);
			}
		}

		//Check to see the if the audio rate is enabled
		tmpstr = props.getElement("Enabled", "Audio_Rate");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_audio_rate = true;
			tmpstr = props.getElement("Value", "Audio_Rate");

			try
			{
				audio_rate = Long.parseLong(tmpstr);
			}
			catch (Exception e)
			{
				System.out.println("Invalid audio rate value property: " + e);
			}
		}

		//Check to see to see if the user wants alter the Library path
		tmpstr = props.getElement("Enabled", "Library_Path");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_library_path = true;
			library_path = props.getElement("Value", "Library_Path");
		}

		//Check to see to see if the user wants alter the executing command
		tmpstr = props.getElement("Enabled", "Exe_Command");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_exe_command = true;
			exe_command = props.getElement("Value", "Exe_Command");
		}

		//Check to see to see if the user wants alter the output format
		tmpstr = props.getElement("Enabled", "Output_Format");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_output_format = true;
			output_format = props.getElement("Value", "Output_Format");
		}

		//Check to see to see if the user wants alter the video output format
		tmpstr = props.getElement("Enabled", "VCodec");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_vcodec = true;
			vcodec = props.getElement("Value", "VCodec");
		}

		//Check to see to see if the user wants alter the audio output format
		tmpstr = props.getElement("Enabled", "ACodec");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			overwrite_acodec = true;
			acodec = props.getElement("Value", "ACodec");
		}

		//Check to see if the user wants to actually create the my file after the conversion
		tmpstr = props.getElement("Create_MY_File", "properties");
		if (tmpstr.equalsIgnoreCase("False"))
		{
			create_my_file = false;
		}

		//Check to see if the user wants to overwrite the delete source on success flag
		tmpstr = props.getElement("Enabled", "Delete_Source_On_Success");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			if (props.getElement("Value", "Delete_Source_On_Success").equalsIgnoreCase("True"))
				delete_source = true;
			else
				delete_source = false;

			overwrite_delete_source = true;
		}


		//Check to see if the user wants to overwrite the default program used for running the command
		tmpstr = props.getElement("Enabled", "Starting_Program");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			starting_program = props.getElement("Value", "Starting_Program");
			//overwrite_starting_program = true;  NOT IN USE
		}

		//Check to see if the user wants to overwrite the default viewing size;
		tmpstr = props.getElement("Enabled", "Viewing_Size");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			viewing_size = props.getElement("Value", "Viewing_Size");
			viewing_size_flag = props.getElement("Flag", "Viewing_Size");
			overwrite_viewing_size = true;
		}

		//Check to see if the user wants to overwrite the default quality
		tmpstr = props.getElement("Enabled", "Quality");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			quality = props.getElement("Value", "Quality");
			overwrite_quality = true;
		}

		//Check to see if the user wants to overwrite the default viewing size;
		tmpstr = props.getElement("Enabled", "ASync");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			async = props.getElement("Value", "ASync");
			async_flag = props.getElement("Flag", "ASync");
			overwrite_async = true;
		}

		//Check to see if the user wants to overwrite the default viewing size;
		tmpstr = props.getElement("Enabled", "VSync");
		if (tmpstr.equalsIgnoreCase("True"))
		{
			vsync = props.getElement("Value", "VSync");
			vsync_flag = props.getElement("Flag", "VSync");
			overwrite_vsync = true;
		}

		//Check to see if the user wants to overwrite the delete source on success flag
		tmpstr = props.getElement("Activity_Log", "properties");

		if (!tmpstr.equals(""))
			active_log = tmpstr;

		//Check to see what the pickup file extension is
		pickup_file_ext = props.getElement("Pickup_File_Extension", "properties");

		//Grab the pickup location
		pickup_location = props.getElement("Pickup_Location", "properties");
		
		System.out.println("These are the settings grabbed from the properties.xml:");
		System.out.println("Pick up location: " + pickup_location);
		System.out.println("Pick up file extension: " + pickup_file_ext);
		//System.out.println("Threads: " + thread_count + " :: " + multi_thread); //MULTI-THREADING NOT IMPLEMENTED
		System.out.println("Video_Rate: " + video_rate + " :: " + overwrite_video_rate);
		System.out.println("Audio_Rate: " + audio_rate + " :: " + overwrite_audio_rate);
		System.out.println("Library_Path: " + library_path + " :: " + overwrite_library_path);
		System.out.println("Exe_Command: " + exe_command + " :: " + overwrite_exe_command);
		System.out.println("Output_Format: " + output_format + " :: " + overwrite_output_format);
		System.out.println("Vidoe Codec: " + vcodec + " :: " + overwrite_vcodec);
		System.out.println("Audio Codec: " + acodec + " :: " + overwrite_acodec);
		System.out.println("Create .my file: " + create_my_file);
		System.out.println("Delete source on success: " + delete_source + " :: " + overwrite_delete_source);
	}

	public boolean invalidSetup()
	{
		return !ready_to_process;
	}

	public boolean start()
	{
		File xml_folder = new File(pickup_location);
		//File[] xml_files = xml_folder.listFiles(new fileFilter(pickup_file_ext));
		File[] xml_files = getAllXML(xml_folder);

		try
		{
			FileWriter fw = new FileWriter("ffmpegPickup.log");
			BufferedWriter bw = new BufferedWriter(fw);
			PrintWriter out = new PrintWriter(bw);

			out.println ("[Listing of " + pickup_file_ext + " to be processed]");

			System.out.println ("\n[" + xml_files.length + "] are expected to be converted...");
			//Print out the files that are to be processes
			for (int i = 0; i < xml_files.length; i++)
			{
				out.println(xml_files[i].toString());
				System.out.println(xml_files[i].toString());
			}

			out.println("");

			for (int i = 0; i < xml_files.length; i++)
			{
				try
				{
					out.println("================================================================");
					out.println("STARTED: " + getTime());

					xml_processor pickup_file = new xml_processor(xml_files[i].toString());
					File input_file = new File(doubleUpSlash(pickup_file.getElement("File", "Airing")));

					String show_title = pickup_file.getElement("Title", "Airing").replaceAll(":", "");
				
					long file_video_rate = 0, file_audio_rate = 0;
					String file_library_path = "";
					File output_file, output_dirs;
					boolean file_delete_source = false;
					boolean skip_cleanup = false;
					String tmpstr = "";

					String file_quality, file_viewing_size;

					File locked_file = new File(xml_files[i].toString() + ".locked");

					String file_exe_command = exe_command;

					out.println ("[Input Directory]\n" + doubleUpSlash(getPath(input_file.toString())));
					out.println ("[Input Filename]\n" + getFileName(input_file.toString(), false));

					//----------------------------------------------------------
					//ACTIVE LOGGING

					FileWriter fw2 = new FileWriter(active_log);
					BufferedWriter bw2 = new BufferedWriter(fw2);
					PrintWriter active_out = new PrintWriter(bw2);

					if ((i+1) < xml_files.length)
					{
						active_out.println("current_file~filename~" + input_file.toString());
						active_out.println("current_file~start_time~" + getTime());
						active_out.println("current_file~status~Processing");
						
						try
						{
							active_out.println("next_file~filename~" + getFileName(xml_files[(i+1)].toString().substring(0,xml_files[(i+1)].toString().lastIndexOf(pickup_file_ext)),false));
							active_out.println("next_file~status~Waiting in queue");
						}
						catch (Exception e)
						{
						}
					}
					else
					{
						active_out.println("current_file~filename~" + input_file.toString());
						active_out.println("current_file~starttime~" + getTime());
						active_out.println("current_file~status~Processing");
					}

					active_out.close();

					try
					{
						fw2.close();
						bw2.close();
					}
					catch (Exception e)
					{
					}

					//
					//----------------------------------------------------------


					if (overwrite_video_rate == false)
					{
						try
						{
							tmpstr = pickup_file.getElement("VideoBitrate", "Airing");
							file_video_rate = Long.parseLong(tmpstr);
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the VideoBitrate for this file." + e);
							file_video_rate = video_rate;	//use the default
						}
					}
					else
						file_video_rate = video_rate;

					if (overwrite_audio_rate == false)
					{
						try
						{
							tmpstr = pickup_file.getElement("AudioBitrate", "Airing");
							file_audio_rate = Long.parseLong(tmpstr);
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the AudioBitrate for this file." + e);
							file_audio_rate = audio_rate;	//use the default
						}
					}
					else
						file_audio_rate = audio_rate;


					if (overwrite_library_path == false)
					{
						try
						{
							file_library_path = pickup_file.getElement("TargetRoot", "Airing");
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the AudioBitrate for this file." + e);
							file_library_path = library_path;	//use the default
						}
					}
					else
						file_library_path = library_path;

					if (overwrite_delete_source == false)
					{
						try
						{
							if (pickup_file.getElement("DeleteWhenComplete", "Airing").equalsIgnoreCase("True"))
								file_delete_source = true;
							else
								file_delete_source = false;
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the delete source flag for this file." + e);
							file_delete_source = delete_source;	//use the default
						}						
					}
					else
						file_delete_source = delete_source;

					if (overwrite_quality == false)
					{
						try
						{
							file_quality = pickup_file.getElement("Quality", "Airing");
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the quality flag for this file." + e);
							file_quality = quality;	//use the default
						}	
					}
					else
						file_quality = quality;

					if (overwrite_viewing_size == false)
					{
						try
						{
							file_viewing_size = pickup_file.getElement("Size", "Airing");
						}
						catch(Exception e)
						{
							out.println("\tAn unexpected error occured capturing the quality flag for this file." + e);
							file_viewing_size = viewing_size;	//use the default
						}	
					}
					else
						file_viewing_size = viewing_size;

					//used to create the directories
					output_dirs = new File(file_library_path + "\\" + show_title);
					//using a file data structure 
					output_file = new File(doubleUpSlash(file_library_path) + "\\" + "\\" + doubleUpSlash(createOutputFileName(show_title, input_file.toString())));

					out.println("[Output Directory]\n" + getPath(output_file.toString()));
					out.println("[Output Filename]\n" + getFileName(output_file.toString(), true) + "." + output_format);
					out.println("\n[Video Rate]\n" + file_video_rate + "kbs");
					out.println("[Video Codec]\n" + vcodec);
					out.println("[Audio Rate]\n" + file_audio_rate + "kbps");
					out.println("[Audio Codec]\n" + acodec);

					//makes the directories incase ffmpeg doesn't : )
					output_dirs.mkdirs();

					//replace @INPUT with input_file
					//replace @AUDIO_RATE with file_audio_rate
					//replace @VIDEO_RATE with file_video_rates
					//replace @OUTPUT_FORMAT with output_format
					//replace @OUTPUT with the output file
					//replace @VCODEC with vcodec
					//replace @ACODEC with acodec

					//replace the dynamic symbols in the exe command with the appropriate values
					file_exe_command = file_exe_command.replaceAll("@INPUT", "\"" + doubleUpSlash(input_file.toString()) + "\"");
					file_exe_command = file_exe_command.replaceAll("@AUDIO_RATE", Long.toString(file_audio_rate));
					file_exe_command = file_exe_command.replaceAll("@VIDEO_RATE", Long.toString(file_video_rate));
					file_exe_command = file_exe_command.replaceAll("@OUTPUT_FORMAT", output_format);
					file_exe_command = file_exe_command.replaceAll("@OUTPUT", "\"" + doubleUpSlash(output_file.toString()) + "\"");
					file_exe_command = file_exe_command.replaceAll("@VCODEC", vcodec);
					file_exe_command = file_exe_command.replaceAll("@ACODEC", acodec);

					if (file_quality.equals(""))
						file_exe_command = file_exe_command.replaceAll("@QUALITY", "");
					else
						file_exe_command = file_exe_command.replaceAll("@QUALITY", file_quality);

					if (file_viewing_size.equals(""))
						file_exe_command = file_exe_command.replaceAll("@SIZE", "");
					else
						file_exe_command = file_exe_command.replaceAll("@SIZE", viewing_size_flag + " " + file_viewing_size);

					if (async_flag.equals(""))
						file_exe_command = file_exe_command.replaceAll("@ASYNC", "");
					else
						file_exe_command = file_exe_command.replaceAll("@ASYNC", async_flag + " " + async);

					if (vsync_flag.equals(""))
						file_exe_command = file_exe_command.replaceAll("@VSYNC", "");
					else
						file_exe_command = file_exe_command.replaceAll("@VSYNC", vsync_flag + " " + vsync);
				
					//create the process and wait for it to finish

					int run_val = -1;

					if (input_file.exists() == false)
					{	
						out.println("\n[Error]\nThe input file could not be found:\n\t" + input_file.toString() + "\nThe pickup file will remain, please correct!");
						attempted_xml.add(xml_files[i].toString()); //add so we don't try it again...will keep from an infinite loop
					}
					else
					{
						String pickup_file_name = xml_files[i].toString();

						if (!locked_file.exists())
						{
							try
							{
								if (!xml_files[i].renameTo(new File(pickup_file_name + ".locked")))
								{
									out.println("\n[Error]\nThere was an unexepected error locking the pickup file...");
									
									/*File lock_file = new File(pickup_file_name + ".locked");

									 try
									 {
									 lock_file.createNewFile(); //create the lock file so another process knows it is locked
									 xml_files[i] = lock_file;
									 }
									 catch (Exception e)
									 {
									 }
									 */
								}
							}
							catch (Exception e)
							{
								out.println("\n[Error]\nThere was an unexepected error locking the pickup file...");

								/*
								 File lock_file = new File(pickup_file_name + ".locked");
								 try
								 {
								 lock_file.createNewFile(); //create the lock file so another process knows it is locked
								 xml_files[i] = lock_file;
								 }
								 catch (Exception e2)
								 {
								 }*/
							}

							
							attempted_xml.add(xml_files[i].toString());

							out.println("\n[Executing Command]\n" + starting_program + " " + file_exe_command);
							Process p = Runtime.getRuntime().exec(starting_program + " " + file_exe_command);
							run_val = p.waitFor();

							/*commented out...let's just delete the locked file
							 * 
							 * try
							 {
							 if (!locked_file.renameTo(new File(pickup_file_name))) //the locked file should exist at this point
							 {
							 xml_files[i] = new File(pickup_file_name); //restore the file

							 try
							 {
							 xml_files[i].createNewFile(); //create the xml file in order to delete it in cleanup :: no error codes
							 }
							 catch (Exception e2)
							 {
							 }

							 out.println("\n[Error]\nThere was an unexepected error unlocking the pickup file...");
							 }
							 }
							 catch (Exception e)
							 {
							 xml_files[i] = new File(pickup_file_name);  //restore the file
							 out.println("\n[Error]\nThere was an unexepected error unlocking the pickup file...");

							 try
							 {
							 xml_files[i].createNewFile(); //create the xml file in order to delete it in cleanup :: no error codes
							 }
							 catch (Exception e2)
							 {
							 }
							 }*/
						}
						else
						{
							out.println("[WARNING]\nThe current movie file is locked...skipping and going to next");
							skip_cleanup = true;
						}
					}

					//make sure we are still cleaning up...only case we don't is if the xml file is locked
					if (skip_cleanup == false)
					{
						//if a run_val is other than 0, it is an error code
						if (run_val == 0)
							out.println("\n[Success]\nThe conversion process appears to have completed successfully!!");
						else
							out.println("\n[Error]\nThe conversion process appears to not have completed successfully...please verify!");
				
						//the cleanup sequence is determined on whether or not we have to create the 
						//.my file at the end of each conversion exection
						if (create_my_file == true)
						{
							int clean_result = 0;

							if (pickup_file.getElement("Episode", "Airing").equals(""))
								clean_result = cleanUpSequence(output_file, locked_file,
									output_dirs.toString(), pickup_file.getElement("Title", "Airing"), pickup_file.getElement("Description", "Airing"),
									pickup_file.getElement("StartDate", "Airing") + " " + pickup_file.getElement("StartTime", "Airing"));
							else
								clean_result = cleanUpSequence(output_file, locked_file,
									output_dirs.toString(), pickup_file.getElement("Title", "Airing") + " :: " +
									pickup_file.getElement("Episode", "Airing"), pickup_file.getElement("Description", "Airing"),
									pickup_file.getElement("StartDate", "Airing") + " " + pickup_file.getElement("StartTime", "Airing"));
					
						
							if (clean_result == 1)
								out.println("[Error]\nThe movie file was not actually created like anticipated, it will be attempted next time around.");
							else if (clean_result == 2)
								out.println("[Error]\nThere was an error removing the pickup file, the my file creation succeeded.");
							else if (clean_result == 3)
								out.println("[Error]\nThere was an error creating the .my file and deleting the pickup file.");
							else if (clean_result == 4)
								out.println("[Error]\nThere was an error creating the .my file, the pickup file has been removed.");
							else if (clean_result == 5)
								out.println("[Error]\nThere was an error renaming the movie file to a correct format.");
							else if (clean_result == 6)
								out.println("[Error]\nBoth the pickup file removal and renaming movie file failed");
							else if (clean_result == 7)
								out.println("[Error]\nThere was an error renaming the movie file and creating the pickup file.");
							else if (clean_result == 8)
								out.println("[Error]\nThere was a complete failure in the cleanup process, pickup/my/move renaming.");
							else if (clean_result == 0)
							{
								out.println("[Success]\nThe conversion process was a success and the .my file was created.");
						
								if (file_delete_source == true)
								{
									try
									{
										if (!input_file.delete())
											out.println("[Error]\nThere was an error deleting the input file...");
									}
									catch (Exception e)
									{
										out.println("[Error]\nThere was an error deleting the input file...");
									}
								}
							}
						}
						else
						{
							int clean_result = cleanUpSequence(output_file,xml_files[i]);

							if (clean_result == 1)
								out.println("[Error]\nThe movie file was not actually created like anticipated, it will be attempted next time around.");
							else if (clean_result == 2)
								out.println("[Error]\nThere was an error removing the pickup file.");
							else if (clean_result == 3)
								out.println("[Error]\nThere was an error renaming the movie file to a correct format.");
							else if (clean_result == 4)
								out.println("[Error]\nThere was a complete failure in the pickup process, both the pickup file and renaming movie file.");
							else if (clean_result == 0)
							{
								out.println("[Success]\nThe conversion process was a success, enjoy!");

								if (file_delete_source == true)
								{
									try
									{
										if (!input_file.delete())
											out.println("[Error]\nThere was an error deleting the input file...");
									}
									catch (Exception e)
									{
										out.println("[Error]\nThere was an error deleting the input file...");
									}
								}
							}
						}
					}
					out.println("COMPLETED: " + getTime());

					try
					{
						File active_log_file = new File(active_log);
						active_log_file.delete();
					}
					catch (Exception e)
					{
					}
				
				}
				catch (Exception e)
				{
					out.println("An unexpected exception occured when converting file: " + e);
					e.printStackTrace();
				}
			}

			try
			{
				//check to see if more xml files are there
				//xml_files = xml_folder.listFiles(new fileFilter(pickup_file_ext));
				xml_files = getAllXML(xml_folder);

				if (xml_files.length > 0)
					if (uniqueFilesExist(xml_files))
						start();
					else
						out.close();
				else
					out.close();
			}
			catch (Exception e)
			{
			}

			try
			{
				bw.close();
				fw.close();
			}
			catch (Exception writeClose)
			{
			}
		}
		catch (Exception e)
		{
			System.out.println("Unexpected exception occurred when starting: " + e);
			e.printStackTrace();
		}
		return true;
	}

	private File[] getAllXML(File xml_folder)
	{
		Vector xml_listing = new Vector();
		File[] xml_files = xml_folder.listFiles(new fileFilter(pickup_file_ext));

		for(int i = 0; i < xml_files.length; i++)
			xml_listing.add(xml_files[i]);

		xml_files = xml_folder.listFiles();

		for(int i = 0; i < xml_files.length; i++)
		{
			if (xml_files[i].isDirectory() == true)
			{
				File[] folder_xml = xml_files[i].listFiles(new fileFilter(pickup_file_ext));

				try
				{
					for(int j = 0; j < folder_xml.length; j++)
					{
						try
						{
							xml_listing.add(folder_xml[j]);
						}
						catch (Exception e)
						{
						}
					}
				}
				catch (Exception e)
				{
				}
			}
		}

		File[] return_xml = new File[xml_listing.size()];
		for(int i = 0; i < xml_listing.size(); i++)
			return_xml[i] = (File)xml_listing.elementAt(i);

		return return_xml;
	}

	//return true if there are unique files in the new list of xml
	private boolean uniqueFilesExist(File[] xml_files)
	{
		boolean unique_files = false;

		for (int i = 0; i < xml_files.length; i++)
		{
			boolean found = false;

			for (int j = 0; j < attempted_xml.size(); j++)
			{
				System.out.println("Element at: " + attempted_xml.elementAt(j).toString());

				if (xml_files[i].toString().equalsIgnoreCase(attempted_xml.elementAt(j).toString()))
				{
					found = true;
					j = attempted_xml.size();
				}
			}

			//must mean it wasn't found in the attempted list
			if (found == false)
				unique_files = true;
		}

		return unique_files;
	}
	private String createOutputFileName(String show_title, String input_file_name)
	{
		String tmpstr = getFileName(input_file_name, true);

		//return "\\" + show_title + "\\" + "\\" +  tmpstr + "." + output_format;
		return "\\" + show_title + "\\" + "\\" +  tmpstr + "." + output_format.substring(0, output_format.length() - 1) + "_";
	}

	//painful cuz regex kept having internal errors in the replaceAll method
	private String doubleUpSlash(String single_slash_path)
	{
		String tmpstr = "";
		String remaining = single_slash_path;

		while (remaining.indexOf("\\") != -1)
		{
			if (tmpstr.equals(""))
			{
				tmpstr = remaining.substring(0,remaining.indexOf("\\"));
			}
			else
			{
				tmpstr += "\\\\" + remaining.substring(0,remaining.indexOf("\\"));
			}
	
			remaining = remaining.substring(remaining.indexOf("\\") + 1);
		}

		tmpstr += "\\\\" + remaining;

		return tmpstr;
	}

	private String getFileName(String complete_path, boolean cut_ext)
	{
		String tmpstr = complete_path;

		//get the filename w/ extension
		while (tmpstr.indexOf("\\") != -1)
		{
			tmpstr = tmpstr.substring(tmpstr.indexOf("\\") + 1);
		}
		
		//cut off the extension
		if (cut_ext == true)
			tmpstr = tmpstr.substring(0, tmpstr.lastIndexOf("."));

		//System.out.println("name = " + tmpstr);
		return tmpstr;
	}

	private String getPath(String complete_file_name)
	{
		String tmpstr = complete_file_name;
		String returnstr = "";

		returnstr = tmpstr.substring(0,tmpstr.lastIndexOf("\\"));

		//System.out.println("path = " + returnstr);
		return returnstr;
	}

	//http://www.rgagnon.com/javadetails/java-0106.html
	private String getTime()
	{
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
    
		String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
		java.text.SimpleDateFormat date_format = new java.text.SimpleDateFormat(DATE_FORMAT);
		/*
		 ** on some JDK, the default TimeZone is wrong
		 ** we must set the TimeZone manually!!!
		 **     sdf.setTimeZone(TimeZone.getTimeZone("EST"));
		 */
		date_format.setTimeZone(TimeZone.getDefault());          
          
		return date_format.format(cal.getTime());

	}

	private int cleanUpSequence(File output_file, File pickup)
	{
		int result = 1; //default to the file not being created...alarms the user if something here goes wrong.

		if (output_file.exists() == true)
		{
			try
			{
				try
				{
					output_file.renameTo(new File((output_file.toString()).substring(0, (output_file.toString()).lastIndexOf(".")) + "." + output_format));
					result = 0;
				}
				catch (Exception e)
				{
					System.out.println("An unexpected exception occured when renaming the output movie file...");
					e.printStackTrace();
					result = 3;
				}

				if (!pickup.delete())
					if (result == 3)
						result = 4;
					else
						result = 2;

				/*if (pickup.toString().endsWith(".locked"))
				 {
				 pickup.delete();

				 //attempt to delete a non-locked xml file if exists
				 pickup = new File(pickup.toString().substring(0, pickup.toString().lastIndexOf(".locked")));

				 if (!pickup.delete())
				 if (result == 3)
				 result = 4;
				 else
				 result = 2;
				 }
				 else
				 {
				 if (!pickup.delete())
				 if (result == 3)
				 result = 4;
				 else
				 result = 2;
				 }*/
			}
			catch (Exception e)
			{
				System.out.println("An unexpected exception occured when removing the pickup file...");
				e.printStackTrace();

				if (result == 3)
					result = 4;
				else
					result = 2;
			}
		}
		else
		{
			System.out.println("The movie file: " + output_file.toString() + " was not created this time around...");
			result = 1;
		}

		return result;
	}
	
	private int cleanUpSequence(File output_file, File pickup, String dir, String title, String overview, String released)
	{
		int result = 1; //default to the file not being created...alarms the user if something here goes wrong.

		if (output_file.exists() == true)
		{
			try
			{
				try
				{
					try
					{
						output_file.renameTo(new File((output_file.toString()).substring(0, (output_file.toString()).lastIndexOf(".")) + "." + output_format));
						result = 0;
					}
					catch (Exception e)
					{
						System.out.println("An unexpected exception occured when renaming the output movie file...");
						e.printStackTrace();
						result = 5;
					}

					if (!pickup.delete())
					{
						if (result == 5)
							result = 6;
						else
							result = 2;
					}

				}
				catch (Exception e)
				{
					System.out.println("An unexpected exception occured when removing the pickup file...");
					e.printStackTrace();

					if (result == 5)
						result = 6;
					else
						result = 2;
				}

				FileWriter fw = new FileWriter(getPath(output_file.toString()) + "\\" + getFileName(output_file.toString(), true) + ".my");
				BufferedWriter bw = new BufferedWriter(fw);
				PrintWriter out = new PrintWriter(bw);

				out.println("title=" + title);
				out.println("overview=" + overview);
				out.println("released=" + released);

				out.close();

				try
				{
					bw.close();
					fw.close();
				}
				catch (Exception writeClose)
				{
				}

			}
			catch (Exception e)
			{
				System.out.println("An unexpected exception occurred when trying to create the .my file...");
				e.printStackTrace();

				if (result == 2)
					result = 3;
				else if(result == 5)
					result = 7;
				else if(result == 6)
					result = 8;
				else
					result = 4;
			}
		}
		else
		{
			System.out.println("The movie file: " + output_file.toString() + " was not created this time around...");
			result = 1;
		}

		return result;
	}
}