import javax.xml.parsers.*;
import org.w3c.dom.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.xml.sax.*;
import java.io.*;
import java.util.*;

public class xml_processor
{
	Document doc = null;

	public xml_processor(String uri)
	{
		try 
		{
			// Create a builder factory
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setValidating(false); //could be set to true to validate against dtd

			// Create the builder and parse the file
			doc = factory.newDocumentBuilder().parse(uri);
		} 
		catch (SAXException e) 
		{
			// A parsing error occurred; the xml input is not valid
			System.out.println("Error parsing the xml, the input is not valid: " + e);
			e.printStackTrace();
		} 
		catch (ParserConfigurationException e) 
		{
			System.out.println("An unexpected ParserConfigurationException occured: " + e);
			e.printStackTrace();
		} 
		catch (IOException e) 
		{
			System.out.println("An unexpected IO error occured: " + e);
			e.printStackTrace();
		}
		catch (Exception e)
		{
			System.out.println("An unexepection exception occured: " +e);
			e.printStackTrace();
		}
	}

	//Returns the DOM Document
	public Document getDocument()
	{
		return doc;
	}

	//Returns true if there were no errors creating the document
	public boolean readableDoc()
	{
		if (doc == null)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	public String getElement(String tag, String parent)
	{
		String tmpstr = "";

		try
		{
			NodeList tmpNodes = doc.getElementsByTagName(parent);

			//get the first match
			NodeList tmpChildNodes = tmpNodes.item(0).getChildNodes();


			for (int i = 0; i < tmpChildNodes.getLength(); i++)
			{

				if (tmpChildNodes.item(i).getNodeName() == tag)
				{
					tmpstr = tmpChildNodes.item(i).getFirstChild().getNodeValue();
				}
			}

		}
		catch (Exception e)
		{
			System.out.println("Unexpection exception parsing the element: " + tag + "\n" + e);
			e.printStackTrace();
		}

		return tmpstr;
	}

	public String getElement(String tag)
	{
		String tmpstr = "";

		try
		{
			NodeList tmpNodes = doc.getElementsByTagName(tag);
			tmpstr = stripXML(tmpNodes.item(0).toString(), tag);
		}
		catch (Exception e)
		{
			System.out.println("Unexpection exception parsing the element: " + tag + "\n" + e);
			e.printStackTrace();
		}

		return tmpstr;
	}

	public NodeList getNodeList(String tag)
	{
		NodeList tmpNodes = doc.getElementsByTagName(tag);
		return tmpNodes;
	}

	//This functions trings the xml from its tag
	//it also does some trimming and fixing for erroneous characters
	public String stripXML(String xml, String tag)
	{
		if ((xml.indexOf("<" + tag + ">") == -1 && xml.indexOf("</" + tag + ">") == -1) || (xml.indexOf("<" + tag) == -1 && xml.indexOf("/>") == -1))
			return "";
		else if (xml.indexOf("<" + tag) == 1 && xml.indexOf("/>") == xml.length() - 2)
		{
			String tmp;

			tmp = xml.substring(xml.indexOf("<" + tag) + tag.length() + 1, xml.indexOf("/>"));			
			tmp = tmp.trim();

			return tmp;
		}
		else
		{
			String tmp;

			tmp = xml.substring(xml.indexOf("<" + tag + ">") + tag.length() + 2, xml.indexOf("</" + tag + ">"));
			tmp = tmp.trim();

			/* This was special trimming for the weather module...
			 * Should not be needed but is here only for reference.
			 * 
			 //gets rid of the weird (A) character
			 if (tmp.indexOf((char)194) != -1)
			 {
			 tmp = tmp.substring(0, tmp.indexOf((char)194)) + tmp.substring(tmp.indexOf((char)194) + 1);
			 }

			 //trim didn't do its job
			 if ((int)tmp.charAt(0) == 32)
			 tmp = tmp.substring(1);

			 if ((int)tmp.charAt(tmp.length() -1) == 32)
			 tmp = tmp.substring(0, tmp.length() - 1);
			 */

			return tmp;
		}
	}
}